Index: c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,104 @@
+##
+#
+# @file
+#
+# @ingroup mpc55xx_config
+#
+# @brief Makefile of LibBSP for the MPC55xx evaluation boards.
+#
+
+ACLOCAL_AMFLAGS = -I ../../../../aclocal
+
+include $(top_srcdir)/../../../../automake/compile.am
+include $(top_srcdir)/../../bsp.am
+
+libcpudir = ../../../libcpu/@RTEMS_CPU@
+
+DISTCLEANFILES = include/bspopts.h
+
+# Compiler specs
+dist_project_lib_DATA = bsp_specs
+
+# Object files
+EXTRA_DIST = startup/start.S
+start.$(OBJEXT): startup/start.S
+	$(CPPASCOMPILE) -o $@ -c $<
+project_lib_DATA = start.$(OBJEXT)
+
+EXTRA_DIST += ../shared/start/rtems_crti.S
+rtems_crti.$(OBJEXT): ../shared/start/rtems_crti.S
+	$(CPPASCOMPILE) -o $@ -c $<
+project_lib_DATA += rtems_crti.$(OBJEXT)
+
+# Link commands
+dist_project_lib_DATA += startup/linkcmds startup/linkcmds.memory
+
+# Includes
+include_HEADERS = include/bsp.h
+
+nodist_include_HEADERS = include/bspopts.h ../../shared/tod.h
+include_bspdir = $(includedir)/bsp
+include_bsp_HEADERS = include/mpc55xxevb.h \
+	include/irq-config.h \
+	../../shared/include/irq-generic.h \
+	../shared/include/tictac.h
+
+# BSP library
+noinst_LIBRARIES = libbsp.a
+libbsp_a_SOURCES =
+libbsp_a_LIBADD = $(libcpudir)/shared/cpuIdent.rel \
+	$(libcpudir)/shared/cache.rel \
+	$(libcpudir)/shared/stack.rel \
+	$(libcpudir)/@RTEMS_CPU_MODEL@/misc.rel \
+	$(libcpudir)/@RTEMS_CPU_MODEL@/irq.rel \
+	$(libcpudir)/@RTEMS_CPU_MODEL@/edma.rel \
+	$(libcpudir)/@RTEMS_CPU_MODEL@/dspi.rel \
+	$(libcpudir)/@RTEMS_CPU_MODEL@/esci.rel \
+	$(libcpudir)/@exceptions@/rtems-cpu.rel \
+	$(libcpudir)/@exceptions@/raw_exception.rel \
+	$(libcpudir)/@exceptions@/exc_bspsupport.rel
+
+# Startup
+noinst_PROGRAMS = startup.rel
+startup_rel_SOURCES = ../../shared/bsplibc.c \
+	../../shared/bsppost.c \
+	../../shared/bootcard.c \
+	../shared/src/tictac.c \
+	startup/bspclean.c \
+	startup/bspstart.c
+startup_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+libbsp_a_LIBADD += startup.rel
+
+# Clock
+noinst_PROGRAMS += clock.rel
+clock_rel_SOURCES = ../shared/clock/clock.c
+clock_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+libbsp_a_LIBADD += clock.rel
+
+# IRQ
+noinst_PROGRAMS += irq-generic.rel
+irq_generic_rel_SOURCES = ../../shared/src/irq-generic.c \
+	../../shared/src/irq-legacy.c
+irq_generic_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+libbsp_a_LIBADD += irq-generic.rel
+
+# Tests
+noinst_PROGRAMS += tests.rel
+tests_rel_SOURCES = tests/tests.c \
+	startup/sd-card-init.c
+tests_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+libbsp_a_LIBADD += tests.rel
+
+# Network
+if HAS_NETWORKING
+noinst_PROGRAMS += network.rel
+network_rel_SOURCES = network/network.c
+network_rel_CPPFLAGS = $(AM_CPPFLAGS) -D__INSIDE_RTEMS_BSD_TCPIP_STACK__ -D__BSD_VISIBLE
+network_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+libbsp_a_LIBADD += network.rel
+endif
+
+include $(srcdir)/preinstall.am
+include $(top_srcdir)/../../../../automake/local.am
+
+BUILT_SOURCES = preinstall
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/README
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/README	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/README	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,64 @@
+OVERVIEW
+========
+
+BSP NAME:           mpc55xxevb
+BOARD:              Freescale MPC5566 evaluation board MPC5566EVB
+BUS:                N/A
+CPU FAMILY:         ppc
+CPU:                PowerPC e200z6
+COPROCESSORS:       N/A
+MODE:               32 bit mode
+DEBUG MONITOR:      BAM
+
+PERIPHERALS
+===========
+
+TIMERS:             not yet supported
+  RESOLUTION:       not yet supported
+SERIAL PORTS:       2 internal eSCI
+REAL-TIME CLOCK:    N/A
+DMA:                eDMA
+VIDEO:              N/A
+SCSI:               N/A
+NETWORKING:         FEC (not yet supported)
+SPI:                DSPI
+
+DRIVER INFORMATION
+==================
+
+CLOCK DRIVER:       Book E decrementer
+IOSUPP DRIVER:      N/A
+SHMSUPP:            N/A
+TIMER DRIVER:       not yet supported
+TTY DRIVER:         BSP
+
+STDIO
+=====
+
+PORT:               ESCI A
+ELECTRICAL:         N/A
+BAUD:               115200
+BITS PER CHARACTER: 8
+PARITY:             N
+STOP BITS:          1
+
+NOTES
+=====
+
+BUS WIDTH:          32 bit Flash, 32 bit SDRAM
+FLASH:              3 MByte
+RAM:                128 kByte SDRAM 
+EXTERNAL RAM:       512 kByte SDRAM 
+
+
+DEBUGGING / CODE LOADING
+========================
+
+Tested using the Lauterbach TRACE32 ICD debugger.
+
+ISSUES
+======
+
+The memory blocks allocated by LibBlock are in general not cache aligned so we
+cannot use DMA transfers.  This is suboptimal in combination with a SD Card and
+SPI.
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/bsp_specs
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/bsp_specs	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/bsp_specs	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,14 @@
+%rename endfile old_endfile
+%rename startfile old_startfile
+%rename link old_link
+
+*startfile:
+%{!qrtems: %(old_startfile)} %{!nostdlib: %{qrtems:  ecrti%O%s rtems_crti%O%s \
+%{!qrtems_debug: start.o%s} \
+%{qrtems_debug: start_g.o%s}}}
+
+*endfile:
+%{!qrtems: %(old_endfile)} %{qrtems: ecrtn.o%s}
+
+*link:
+%{!qrtems: %(old_link)} %{qrtems: -dc -dp -N -u start -e start}
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/configure.ac
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/configure.ac	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/configure.ac	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,53 @@
+##
+#
+# @file
+#
+# @ingroup mpc55xx_config
+#
+# @brief Configure script of LibBSP for the MPC55xx evaluation boards.
+#
+
+AC_PREREQ(2.60)
+AC_INIT([rtems-c-src-lib-libbsp-powerpc-mpc55xxevb],[_RTEMS_VERSION],[http://www.rtems.org/bugzilla])
+AC_CONFIG_SRCDIR([bsp_specs])
+RTEMS_TOP(../../../../../..)
+
+RTEMS_CANONICAL_TARGET_CPU
+AM_INIT_AUTOMAKE([no-define nostdinc foreign 1.10])
+RTEMS_BSP_CONFIGURE
+
+RTEMS_AMPOLISH3
+RTEMS_PROG_CC_FOR_TARGET([-fasm])
+RTEMS_CANONICALIZE_TOOLS
+RTEMS_PROG_CCAS
+
+RTEMS_CHECK_NETWORKING
+AM_CONDITIONAL(HAS_NETWORKING,test "$HAS_NETWORKING" = "yes")
+
+RTEMS_BSPOPTS_SET([UARTS_USE_TERMIOS],[*],[0])
+RTEMS_BSPOPTS_HELP([UARTS_USE_TERMIOS],
+[Define to 1 if you want termios support for every port.
+ Termios support is independent of the choice of UART I/O mode.])
+
+RTEMS_BSPOPTS_SET([CONSOLE_MINOR],[*],[MPC55XX_ESCI_A_MINOR])
+RTEMS_BSPOPTS_HELP([CONSOLE_MINOR],
+[Must be defined to be one of MPC55XX_ESCI_A_MINOR or MPC55XX_ESCI_B_MINOR.  Determines which
+ device will be registered as /dev/console.])
+
+RTEMS_BSPOPTS_SET([UARTS_IO_MODE],[*],[0])
+RTEMS_BSPOPTS_HELP([UARTS_IO_MODE],
+[Define to 1 if you want interrupt-driven I/O for the SCI ports.])
+
+RTEMS_BSPOPTS_SET([PRINTK_MINOR],[*],[MPC55XX_ESCI_B_MINOR])
+RTEMS_BSPOPTS_HELP([PRINTK_MINOR],
+[Must be defined to be one of MPC55XX_ESCI_A_MINOR or MPC55XX_ESCI_B_MINOR.  Determines which
+ device is used for output by printk().  The printk port always uses polled
+ I/O.  Don't open the printk port from RTEMS unless also using polled I/O
+ for the SCI ports.])
+
+AC_CONFIG_FILES([Makefile
+include/bspopts.h])
+
+RTEMS_PPC_EXCEPTIONS
+
+AC_OUTPUT
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/include/bsp.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/include/bsp.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,54 @@
+/**
+ * @file
+ *
+ * @ingroup mpc55xx
+ *
+ * @brief Global BSP variables and functions
+ */
+
+/*
+ * Copyright (c) 2008
+ * Embedded Brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * rtems@embedded-brains.de
+ *
+ * The license and distribution terms for this file may be found in the file
+ * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+ */
+
+#ifndef LIBBSP_POWERPC_BSP_H
+#define LIBBSP_POWERPC_BSP_H
+
+#include <stdint.h>
+
+#include <rtems.h>
+#include <rtems/console.h>
+#include <rtems/clockdrv.h>
+
+#include <bspopts.h>
+
+#include <bsp/tictac.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+#ifndef ASM
+
+/** @brief System clock frequency */
+extern unsigned int bsp_clock_speed;
+
+/** @brief Time base clicks per micro second */
+extern uint32_t bsp_clicks_per_usec;
+
+rtems_status_code mpc55xx_sd_card_init();
+
+#endif /* ASM */
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* LIBBSP_POWERPC_BSP_H */
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/include/irq-config.h
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/include/irq-config.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/include/irq-config.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,76 @@
+/**
+ * @file
+ *
+ * @ingroup bsp_interrupt
+ *
+ * @brief BSP interrupt support configuration.
+ */
+
+/*
+ * Copyright (c) 2008
+ * Embedded Brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * rtems@embedded-brains.de
+ *
+ * The license and distribution terms for this file may be found in the file
+ * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+ */
+
+#ifndef LIBBSP_POWERPC_MPC55XXEVB_IRQ_CONFIG_H
+#define LIBBSP_POWERPC_MPC55XXEVB_IRQ_CONFIG_H
+
+#include <stdint.h>
+
+/**
+ * @addtogroup bsp_interrupt
+ *
+ * @{
+ */
+
+/**
+ * @brief Minimum vector number.
+ */
+#define BSP_INTERRUPT_VECTOR_MIN 0
+
+/**
+ * @brief Maximum vector number.
+ */
+#define BSP_INTERRUPT_VECTOR_MAX 328
+
+/**
+ * @brief Enables the index table.
+ *
+ * If you enable the index table, you have to define a size for the handler
+ * table (@ref BSP_INTERRUPT_HANDLER_TABLE_SIZE) and must provide an integer
+ * type capable to index the complete handler table (@ref
+ * bsp_interrupt_handler_index_type).
+ */
+#define BSP_INTERRUPT_USE_INDEX_TABLE
+
+/**
+ * @brief Disables usage of the heap.
+ *
+ * If you define this, you have to define @ref BSP_INTERRUPT_USE_INDEX_TABLE as
+ * well.
+ */
+#define BSP_INTERRUPT_NO_HEAP_USAGE
+
+#ifdef BSP_INTERRUPT_USE_INDEX_TABLE
+
+/**
+ * @brief Size of the handler table.
+ */
+#define BSP_INTERRUPT_HANDLER_TABLE_SIZE 63
+
+/**
+ * @brief Integer type capable to index the complete handler table.
+ */
+typedef uint8_t bsp_interrupt_handler_index_type;
+
+#endif /* BSP_INTERRUPT_USE_INDEX_TABLE */
+
+/** @} */
+
+#endif /* LIBBSP_POWERPC_MPC55XXEVB_IRQ_CONFIG_H */
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/include/mpc55xxevb.h
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/include/mpc55xxevb.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/include/mpc55xxevb.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,28 @@
+/**
+ * @file
+ *
+ * @ingroup mpc55xx
+ *
+ * @brief Documentation for this file
+ *
+ * More details.
+ * 
+ * @par Copyright
+ * Copyright (c) 2008<br>
+ * Embedded Brains GmbH<br>
+ * Obere Lagerstr. 30<br>
+ * D-82178 Puchheim<br>
+ * Germany<br>
+ * rtems@embedded-brains.de<br>
+ *
+ * @par License
+ * The license and distribution terms for this file may be found in the file
+ * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+ */
+
+#ifndef LIBBSP_POWERPC_MPC55XXEVB_H
+#define LIBBSP_POWERPC_MPC55XXEVB_H
+
+/* TODO */
+
+#endif /* LIBBSP_POWERPC_MPC55XXEVB_H */
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/network/network.c
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/network/network.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/network/network.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,21 @@
+/**
+ * @file
+ *
+ * @ingroup mpc55xx
+ *
+ * @brief Documentation for this file
+ *
+ * More details.
+ * 
+ * @par Copyright
+ * Copyright (c) 2008<br>
+ * Embedded Brains GmbH<br>
+ * Obere Lagerstr. 30<br>
+ * D-82178 Puchheim<br>
+ * Germany<br>
+ * rtems@embedded-brains.de<br>
+ *
+ * @par License
+ * The license and distribution terms for this file may be found in the file
+ * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+ */
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/startup/bspclean.c
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/startup/bspclean.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/startup/bspclean.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,24 @@
+/**
+ * @file
+ *
+ * @ingroup mpc55xx
+ *
+ * @brief BSP cleanup code
+ */
+
+/*
+ * Copyright (c) 2008
+ * Embedded Brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * rtems@embedded-brains.de
+ *
+ * The license and distribution terms for this file may be found in the file
+ * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+ */
+
+void bsp_cleanup()
+{
+	// TODO
+}
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/startup/bspstart.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/startup/bspstart.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,263 @@
+/**
+ * @file
+ *
+ * @ingroup mpc55xx
+ *
+ * @brief BSP startup code.
+ */
+
+/*
+ * Copyright (c) 2008
+ * Embedded Brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * rtems@embedded-brains.de
+ *
+ * The license and distribution terms for this file may be found in the file
+ * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+ */
+
+#include <mpc55xx/mpc55xx.h>
+#include <mpc55xx/regs.h>
+#include <mpc55xx/edma.h>
+
+#include <rtems.h>
+#include <rtems/bspIo.h>
+#include <rtems/libcsupport.h>
+
+#include <libcpu/powerpc-utility.h>
+
+#include <bsp.h>
+#include <bsp/irq.h>
+#include <bsp/irq-generic.h>
+#include <bsp/ppc_exc_bspsupp.h>
+
+#define RTEMS_STATUS_CHECKS_USE_PRINTK
+
+#include <rtems/status-checks.h>
+
+#define DEBUG_DONE() DEBUG_PRINT( "Done\n")
+
+#define MPC55XX_INTERRUPT_STACK_SIZE 0x1000
+
+/* Symbols defined in linker command file */
+LINKER_SYMBOL( bsp_ram_start);
+LINKER_SYMBOL( bsp_ram_end);
+LINKER_SYMBOL( bsp_external_ram_start);
+LINKER_SYMBOL( bsp_external_ram_size);
+LINKER_SYMBOL( bsp_section_bss_end);
+
+unsigned int bsp_clock_speed = 0;
+
+uint32_t bsp_clicks_per_usec = 0;
+
+void BSP_panic( char *s)
+{
+	rtems_interrupt_level level;
+
+	rtems_interrupt_disable( level);
+
+	printk( "%s PANIC %s\n", _RTEMS_version, s);
+
+	while (1) {
+		/* Do nothing */
+	}
+}
+
+void _BSP_Fatal_error( unsigned n)
+{
+	rtems_interrupt_level level;
+
+	rtems_interrupt_disable( level);
+
+	printk( "%s PANIC ERROR %u\n", _RTEMS_version, n);
+
+	while (1) {
+		/* Do nothing */
+	}
+}
+
+void bsp_pretasking_hook()
+{
+	uint32_t heap_start = bsp_external_ram_start;
+	uint32_t heap_size = bsp_external_ram_size;
+
+	bsp_libc_init( heap_start, heap_size, 0);
+
+#ifdef STACK_CHECKER_ON
+	Stack_check_Initialize();
+#endif
+
+#ifdef RTEMS_DEBUG
+	rtems_debug_enable( RTEMS_DEBUG_ALL_MASK );
+#endif
+}
+
+void bsp_predriver_hook()
+{
+	rtems_status_code sc = RTEMS_SUCCESSFUL;
+
+	DEBUG_PRINT( "Initialize eDMA ...\n");
+	sc = mpc55xx_edma_init();
+	if (sc != RTEMS_SUCCESSFUL) {
+		BSP_panic( "Cannot initialize eDMA");
+	} else {
+		DEBUG_DONE();
+	}
+}
+
+static void mpc55xx_ebi_init()
+{
+	struct EBI_CS_tag cs = { BR : MPC55XX_ZERO_FLAGS, OR : MPC55XX_ZERO_FLAGS };
+	union SIU_PCR_tag pcr = MPC55XX_ZERO_FLAGS;
+	int i = 0;
+
+	/* External SRAM (0 wait states, 512kB, 4 word burst) */
+	cs.BR.B.BA = 0;
+	cs.BR.B.PS = 1;
+	cs.BR.B.BL = 1;
+	cs.BR.B.WEBS = 0;
+	cs.BR.B.TBDIP = 0;
+	cs.BR.B.BI = 1; /* TODO: Enable burst */
+	cs.BR.B.V = 1;
+
+	cs.OR.B.AM = 0x1fff0;
+	cs.OR.B.SCY = 0;
+	cs.OR.B.BSCY = 0;
+
+	EBI.CS [0] = cs;
+
+	/* !CS [0] */
+	SIU.PCR [0].R = 0x443;
+
+	/* ADDR [8 : 31] */
+	for (i = 4; i < 4 + 24; ++i) {
+		SIU.PCR [i].R = 0x440;
+	}
+
+	/* DATA [0 : 15] */
+	for (i = 28; i < 28 + 16; ++i) {
+		SIU.PCR [i].R = 0x440;
+	}
+
+	/* RD_!WR */
+	SIU.PCR [62].R = 0x443;
+
+	/* !BDIP */
+	SIU.PCR [63].R = 0x443;
+
+	/* !WE [0 : 3] */
+	for (i = 64; i < 64 + 4; ++i) {
+		SIU.PCR [i].R = 0x443;
+	}
+
+	/* !OE */
+	SIU.PCR [68].R = 0x443;
+
+	/* !TS */
+	SIU.PCR [69].R = 0x443;
+}
+
+/**
+ * @brief Start BSP.
+ */
+void bsp_start(void)
+{
+	ppc_cpu_id_t myCpu;
+	ppc_cpu_revision_t myCpuRevision;
+
+	uint32_t ram_start = bsp_ram_start;
+	uint32_t ram_end = bsp_ram_end;
+	uint32_t interrupt_stack_start = ram_end - 2 * MPC55XX_INTERRUPT_STACK_SIZE;
+	uint32_t interrupt_stack_size = MPC55XX_INTERRUPT_STACK_SIZE;
+	uint32_t work_space_start = bsp_section_bss_end;
+	uint32_t work_space_end = work_space_start + rtems_configuration_get_work_space_size();
+
+	/* ESCI pad configuration */
+	SIU.PCR [89].R = 0x400;
+	SIU.PCR [90].R = 0x400;
+
+	DEBUG_PRINT( "BSP start ...\n");
+
+	/* Memory layout */
+
+	Configuration.work_space_start = work_space_start;
+
+	DEBUG_PRINT( "System clock          : %i\n", mpc55xx_get_system_clock());
+	DEBUG_PRINT( "Memory start          : 0x%08x\n", ram_start);
+	DEBUG_PRINT( "Memory end            : 0x%08x\n", ram_end);
+	DEBUG_PRINT( "Memory size           : 0x%08x\n", ram_end - ram_start);
+	DEBUG_PRINT( "Work space start      : 0x%08x\n", work_space_start);
+	DEBUG_PRINT( "Work space end        : 0x%08x\n", work_space_end);
+	DEBUG_PRINT( "Work space size       : 0x%08x\n", work_space_end - work_space_start);
+	DEBUG_PRINT( "Interrupt stack start : 0x%08x\n", interrupt_stack_start);
+	DEBUG_PRINT( "Interrupt stack end   : 0x%08x\n", interrupt_stack_start + interrupt_stack_size);
+	DEBUG_PRINT( "Interrupt stack size  : 0x%08x\n", interrupt_stack_size);
+
+	if (work_space_end > interrupt_stack_start) {
+		BSP_panic( "Not enough memory for the work space");
+	}
+	
+	/*
+	 * Get CPU identification dynamically. Note that the get_ppc_cpu_type()
+	 * function store the result in global variables so that it can be used
+	 * latter...
+	 */
+	myCpu = get_ppc_cpu_type();
+	myCpuRevision = get_ppc_cpu_revision();
+	
+	/* Time reference value */
+	bsp_clicks_per_usec = bsp_clock_speed / 1000000;
+
+	/* Initialize External Bus Interface */
+	mpc55xx_ebi_init();
+	
+	/* Initialize exceptions */
+	DEBUG_PRINT( "Initialize exceptions ...\n");
+	ppc_exc_initialize( PPC_INTERRUPT_DISABLE_MASK_DEFAULT, interrupt_stack_start, interrupt_stack_size);
+	DEBUG_DONE();
+
+	/* Initialize interrupts */
+	DEBUG_PRINT( "Initialize interrupts ...\n");
+	if (bsp_interrupt_initialize() != RTEMS_SUCCESSFUL) {
+		BSP_panic( "Cannot initialize interrupts");
+	} else {
+		DEBUG_DONE();
+	}
+	
+	DEBUG_PRINT( "BSP start done\n");
+
+	return;
+
+	/* TODO */
+	/*
+	* Enable instruction and data caches. Do not force writethrough mode.
+	*/
+#if INSTRUCTION_CACHE_ENABLE
+	rtems_cache_enable_instruction();
+#endif
+#if DATA_CACHE_ENABLE
+	rtems_cache_enable_data();
+#endif
+}
+
+/**
+ * @brief Idle thread body.
+ */
+Thread _Thread_Idle_body( uint32_t ignored)
+{
+
+	while (1) {
+		asm volatile(
+			"mfmsr 3;"
+			"oris 3,3,4;"
+			"sync;"
+			"mtmsr 3;"
+			"isync;"
+			"ori 3,3,0;"
+			"ori 3,3,0"
+		);
+	}
+	return 0;
+}
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/startup/linkcmds
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/startup/linkcmds	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/startup/linkcmds	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,278 @@
+/**
+ * @file
+ *
+ * Derived from internal linker script of GNU ld (GNU Binutils) 2.18 for elf32ppc emulation.
+ */
+
+OUTPUT_FORMAT("elf32-powerpc", "elf32-powerpc", "elf32-powerpc")
+OUTPUT_ARCH(powerpc)
+ENTRY(start)
+
+INCLUDE linkcmds.memory
+
+SECTIONS
+{
+	.text : {
+		/*
+		 * BSP: Start of text section
+		 */
+		bsp_section_text_start = .;
+
+		/*
+		 * BSP: System startup entry
+		 */
+		KEEP (*(.entry))
+
+		/*
+		 * BSP: Moved into .text from .init
+		 */
+		KEEP (*(.init))
+
+		*(.text .stub .text.* .gnu.linkonce.t.*)
+		KEEP (*(.text.*personality*))
+		/* .gnu.warning sections are handled specially by elf32.em.  */
+		*(.gnu.warning)
+		*(.glink)
+		
+		/*
+		 * BSP: Special FreeBSD sysctl sections
+		 */
+		. = ALIGN (16);
+		__start_set_sysctl_set = .;
+		*(set_sysctl_*);
+		__stop_set_sysctl_set = ABSOLUTE(.);
+		*(set_domain_*);
+		*(set_pseudo_*);
+
+		/*
+		 * BSP: Moved into .text from .*
+		 */
+		*(.rodata .rodata.* .gnu.linkonce.r.*)
+		*(.rodata1)
+		*(.interp)
+		*(.note.gnu.build-id)
+		*(.hash)
+		*(.gnu.hash)
+		*(.dynsym)
+		*(.dynstr)
+		*(.gnu.version)
+		*(.gnu.version_d)
+		*(.gnu.version_r)
+		*(.eh_frame_hdr)
+
+		/*
+		 * BSP: Magic PPC stuff
+		 */
+		*(.PPC.*)
+
+		/*
+		 * BSP: Required by cpukit/score/src/threadhandler.c
+		 */
+		PROVIDE (_fini = .);
+
+		/*
+		 * BSP: Moved into .text from .fini
+		 */
+		KEEP (*(.fini))
+
+		. = ALIGN (bsp_section_align);
+
+		PROVIDE (__etext = .);
+		PROVIDE (_etext = .);
+		PROVIDE (etext = .);
+	} > ROM =0
+
+	.sdata2 : {
+		PROVIDE (_SDA2_BASE_ = 32768);
+
+		*(.sdata2 .sdata2.* .gnu.linkonce.s2.*)
+
+		. = ALIGN (bsp_section_align);
+	} > ROM =0
+
+	.sbss2 : {
+		*(.sbss2 .sbss2.* .gnu.linkonce.sb2.*)
+
+		. = ALIGN (bsp_section_align);
+
+		/*
+		 * BSP: End of text section
+		 */
+		bsp_section_text_end = .;
+	} > ROM =0
+
+	.data : AT (bsp_section_text_end) {
+		/*
+		 * BSP: Start of data section
+		 */
+		bsp_section_data_start = .;
+
+		/*
+		 * BSP: Reserve space for exception handler
+		 */
+		. = . + 0x180;
+
+		/*
+		 * BSP: Moved into .data from .ctors
+		 */
+		/* gcc uses crtbegin.o to find the start of
+		   the constructors, so we make sure it is
+		   first.  Because this is a wildcard, it
+		   doesn't matter if the user does not
+		   actually link against crtbegin.o; the
+		   linker won't look for a file to match a
+		   wildcard.  The wildcard also means that it
+		   doesn't matter which directory crtbegin.o
+		   is in.  */
+		KEEP (*crtbegin.o(.ctors))
+		KEEP (*crtbegin?.o(.ctors))
+		/* We don't want to include the .ctor section from
+		   the crtend.o file until after the sorted ctors.
+		   The .ctor section from the crtend file contains the
+		   end of ctors marker and it must be last */
+		KEEP (*(EXCLUDE_FILE (*crtend.o *crtend?.o ) .ctors))
+		KEEP (*(SORT(.ctors.*)))
+		KEEP (*(.ctors))
+
+		/*
+		 * BSP: Moved into .data from .dtors
+		 */
+		KEEP (*crtbegin.o(.dtors))
+		KEEP (*crtbegin?.o(.dtors))
+		KEEP (*(EXCLUDE_FILE (*crtend.o *crtend?.o ) .dtors))
+		KEEP (*(SORT(.dtors.*)))
+		KEEP (*(.dtors))
+
+		/*
+		 * BSP: Moved into .data from .*
+		 */
+		*(.tdata .tdata.* .gnu.linkonce.td.*)
+		*(.tbss .tbss.* .gnu.linkonce.tb.*) *(.tcommon)
+		*(.data1)
+		KEEP (*(.eh_frame))
+		*(.gcc_except_table .gcc_except_table.*)
+		KEEP (*(.jcr))
+		*(.data.rel.ro.local* .gnu.linkonce.d.rel.ro.local.*) *(.data.rel.ro* .gnu.linkonce.d.rel.ro.*)
+		*(.fixup)
+		*(.got1)
+		*(.got2)
+		*(.dynamic)
+		*(.got)
+		*(.plt)
+		PROVIDE_HIDDEN (__preinit_array_start = .);
+		KEEP (*(.preinit_array))
+		PROVIDE_HIDDEN (__preinit_array_end = .);
+		PROVIDE_HIDDEN (__init_array_start = .);
+		KEEP (*(SORT(.init_array.*)))
+		KEEP (*(.init_array))
+		PROVIDE_HIDDEN (__init_array_end = .);
+		PROVIDE_HIDDEN (__fini_array_start = .);
+		KEEP (*(.fini_array))
+		KEEP (*(SORT(.fini_array.*)))
+		PROVIDE_HIDDEN (__fini_array_end = .);
+
+		*(.data .data.* .gnu.linkonce.d.*)
+		KEEP (*(.gnu.linkonce.d.*personality*))
+		SORT(CONSTRUCTORS)
+
+		. = ALIGN (bsp_section_align);
+	} > RAM
+
+	.sdata : {
+		PROVIDE (_SDA_BASE_ = 32768);
+		*(.sdata .sdata.* .gnu.linkonce.s.*)
+
+		. = ALIGN (bsp_section_align);
+
+		_edata = .;
+		PROVIDE (edata = .);
+
+		/*
+		 * BSP: End of data section
+		 */
+		bsp_section_data_end = .;
+	} > RAM
+
+	.sbss : {
+		/*
+		 * BSP: Start of bss section
+		 */
+		bsp_section_bss_start = .;
+
+		__bss_start = .;
+
+		PROVIDE (__sbss_start = .); PROVIDE (___sbss_start = .);
+		*(.scommon)
+		*(.dynsbss)
+		*(.sbss .sbss.* .gnu.linkonce.sb.*)
+		PROVIDE (__sbss_end = .); PROVIDE (___sbss_end = .);
+
+		. = ALIGN (bsp_section_align);
+	} > RAM
+
+	.bss : {
+		*(COMMON)
+		*(.dynbss)
+		*(.bss .bss.* .gnu.linkonce.b.*)
+
+		. = ALIGN (bsp_section_align);
+
+		__end = .;
+		_end = .;
+		PROVIDE (end = .);
+
+		/*
+		 * BSP: End of bss section
+		 */
+		bsp_section_bss_end = .;
+	} > RAM
+	
+	/* Stabs debugging sections.  */
+	.stab          0 : { *(.stab) }
+	.stabstr       0 : { *(.stabstr) }
+	.stab.excl     0 : { *(.stab.excl) }
+	.stab.exclstr  0 : { *(.stab.exclstr) }
+	.stab.index    0 : { *(.stab.index) }
+	.stab.indexstr 0 : { *(.stab.indexstr) }
+	.comment       0 : { *(.comment) }
+	/* DWARF debug sections.
+	   Symbols in the DWARF debugging sections are relative to the beginning
+	   of the section so we begin them at 0.  */
+	/* DWARF 1 */
+	.debug          0 : { *(.debug) }
+	.line           0 : { *(.line) }
+	/* GNU DWARF 1 extensions */
+	.debug_srcinfo  0 : { *(.debug_srcinfo) }
+	.debug_sfnames  0 : { *(.debug_sfnames) }
+	/* DWARF 1.1 and DWARF 2 */
+	.debug_aranges  0 : { *(.debug_aranges) }
+	.debug_pubnames 0 : { *(.debug_pubnames) }
+	/* DWARF 2 */
+	.debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
+	.debug_abbrev   0 : { *(.debug_abbrev) }
+	.debug_line     0 : { *(.debug_line) }
+	.debug_frame    0 : { *(.debug_frame) }
+	.debug_str      0 : { *(.debug_str) }
+	.debug_loc      0 : { *(.debug_loc) }
+	.debug_macinfo  0 : { *(.debug_macinfo) }
+	/* SGI/MIPS DWARF 2 extensions */
+	.debug_weaknames 0 : { *(.debug_weaknames) }
+	.debug_funcnames 0 : { *(.debug_funcnames) }
+	.debug_typenames 0 : { *(.debug_typenames) }
+	.debug_varnames  0 : { *(.debug_varnames) }
+	/* DWARF 3 */
+	.debug_pubtypes 0 : { *(.debug_pubtypes) }
+	.debug_ranges   0 : { *(.debug_ranges) }
+	.gnu.attributes 0 : { KEEP (*(.gnu.attributes)) }
+
+	/DISCARD/ : {
+		*(.note.GNU-stack) *(.gnu_debuglink)
+	}
+
+	/*
+	 * BSP: Catch all unknown sections
+	 */
+	.nirvana : {
+		*(*)
+	} > NIRVANA
+}
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/startup/linkcmds.memory
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/startup/linkcmds.memory	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/startup/linkcmds.memory	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,21 @@
+MEMORY
+{
+	ROM (RX) : ORIGIN = 0x0, LENGTH = 3M
+	RAM (AIW) : ORIGIN = 0x40000000, LENGTH = 128K
+	EXT_RAM : ORIGIN = 0x20000000, LENGTH = 512K
+	NIRVANA : ORIGIN = 0x0, LENGTH = 0
+}
+
+bsp_ram_start = ORIGIN (RAM);
+bsp_ram_end = ORIGIN (RAM) + LENGTH (RAM);
+bsp_ram_size = LENGTH (RAM);
+
+bsp_rom_start = ORIGIN (ROM);
+bsp_rom_end = ORIGIN (ROM) + LENGTH (ROM);
+bsp_rom_size = LENGTH (ROM);
+
+bsp_external_ram_start = ORIGIN (EXT_RAM);
+bsp_external_ram_end = ORIGIN (EXT_RAM) + LENGTH (EXT_RAM);
+bsp_external_ram_size = LENGTH (EXT_RAM);
+
+bsp_section_align = 32;
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/startup/sd-card-init.c
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/startup/sd-card-init.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/startup/sd-card-init.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,149 @@
+#include  <stdio.h>
+
+#include <mpc55xx/mpc55xx.h>
+#include <mpc55xx/regs.h>
+#include <mpc55xx/dspi.h>
+
+#include <libchip/spi-sd-card.h>
+
+#define DEBUG
+
+#include <rtems/status-checks.h>
+
+#include <bsp.h>
+
+static rtems_status_code mpc55xx_dspi_init()
+{
+	int rv = 0;
+	int i = 0;
+	char device_name [] = "/dev/spi0";
+	union SIU_PCR_tag pcr = MPC55XX_ZERO_FLAGS;
+
+	rv = rtems_libi2c_initialize();
+	CHECK_RVSC( rv, "rtems_libi2c_initialize");
+
+	/* DSPI D inputs are taken from DSPI C */
+	SIU.DISR.R = 0x000000FC;
+
+	/* DSPI A signals */
+	pcr.B.PA = 1;
+	pcr.B.ODE = 0;
+	pcr.B.HYS = 0;
+	pcr.B.SRC = 3;
+	pcr.B.WPE = 1;
+	pcr.B.WPS = 1;
+
+	/* SCK */
+	pcr.B.OBE = 1;
+	pcr.B.IBE = 0;
+	SIU.PCR [93].R = pcr.R;
+
+	/* SIN */
+	pcr.B.OBE = 0;
+	pcr.B.IBE = 1;
+	SIU.PCR [94].R = pcr.R;
+
+	/* SOUT */
+	pcr.B.OBE = 1;
+	pcr.B.IBE = 0;
+	SIU.PCR [95].R = pcr.R;
+
+	/* PCSx */
+	pcr.B.OBE = 1;
+	pcr.B.IBE = 0;
+	SIU.PCR [96].R = pcr.R;
+	SIU.PCR [97].R = pcr.R;
+	SIU.PCR [98].R = pcr.R;
+	SIU.PCR [99].R = pcr.R;
+	SIU.PCR [100].R = pcr.R;
+	SIU.PCR [101].R = pcr.R;
+
+	mpc55xx_dspi_bus_table [3].master = 0;
+	for (i = 0; i < MPC55XX_DSPI_NUMBER; ++i) {
+		device_name [8] = '0' + i;
+		rv = rtems_libi2c_register_bus( device_name, (rtems_libi2c_bus_t *) &mpc55xx_dspi_bus_table [i]);
+		CHECK_RVSC( rv, device_name);
+	}
+
+	return RTEMS_SUCCESSFUL;
+}
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <dirent.h>
+#include <stdio.h>
+#include <rtems/fsmount.h>
+#include <rtems/dosfs.h>
+#include <rtems/ide_part_table.h>
+#include <rtems/console.h>
+
+#define MPC55XX_DEVICE "sd-card-a"
+#define MPC55XX_DEVICE_FILE "/dev/" MPC55XX_DEVICE
+#define MPC55XX_PARTITION "/dev/sd-card-a1"
+#define MPC55XX_MOUNT_POINT "/mnt"
+
+static fstab_t mpc55xx_fs_table [] = { {
+		MPC55XX_PARTITION, MPC55XX_MOUNT_POINT,
+		&msdos_ops, RTEMS_FILESYSTEM_READ_WRITE,
+		FSMOUNT_MNT_OK | FSMOUNT_MNTPNT_CRTERR | FSMOUNT_MNT_FAILED,
+		FSMOUNT_MNT_OK
+	}, {
+		MPC55XX_DEVICE_FILE, MPC55XX_MOUNT_POINT,
+		&msdos_ops, RTEMS_FILESYSTEM_READ_WRITE,
+		FSMOUNT_MNT_OK | FSMOUNT_MNTPNT_CRTERR | FSMOUNT_MNT_FAILED,
+		0
+	}
+};
+
+#define SD_CARD_NUMBER 1
+
+sd_card_driver_entry sd_card_driver_table [SD_CARD_NUMBER] = { {
+		.driver = {
+			.ops = &sd_card_driver_ops,
+			.size = sizeof( sd_card_driver_entry)
+		},
+		.table_index = 0,
+		.minor = 0,
+		.device_name = "sd-card-a",
+		.disk_device_name = "/dev/sd-card-a",
+		.transfer_mode = SD_CARD_TRANSFER_MODE_DEFAULT,
+		.command = SD_CARD_COMMAND_DEFAULT,
+		/* response : whatever, */
+		.response_index = SD_CARD_COMMAND_SIZE,
+		.n_ac_max = SD_CARD_N_AC_MAX_DEFAULT,
+		.block_number = 0,
+		.block_size = 0,
+		.block_size_shift = 0,
+		.busy = 1,
+		.verbose = 1,
+		.schedule_if_busy = 0,
+	}
+};
+
+rtems_status_code mpc55xx_sd_card_init()
+{
+	rtems_status_code sc = RTEMS_SUCCESSFUL;
+	int rv = 0;
+	sd_card_driver_entry *e = &sd_card_driver_table [0];
+
+	DEBUG_PRINT( "Task started\n");
+
+	sc = mpc55xx_dspi_init();
+	CHECK_SC( rv, "Intitalize DSPI bus");
+
+	rv = rtems_libi2c_register_drv( e->device_name, (rtems_libi2c_drv_t *) e, mpc55xx_dspi_bus_table [0].bus_number, 0);
+	CHECK_RVSC( rv, "Register SD Card driver");
+
+	sc = rtems_ide_part_table_initialize( MPC55XX_DEVICE_FILE);
+	CHECK_SC( sc, "Initialize IDE partition table");
+
+	rv = mkdir( MPC55XX_MOUNT_POINT, S_IRWXU);
+	CHECK_RVSC( rv, "Create mount point");
+
+	rv = rtems_fsmount( mpc55xx_fs_table, sizeof( mpc55xx_fs_table) / sizeof( mpc55xx_fs_table [0]), NULL);
+	CHECK_RVSC( rv, "Mount file systems");
+
+	return RTEMS_SUCCESSFUL;
+}
